1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
7 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
8 CERROR
="\e[1;31m" # red
9 CWARNING
="\e[1;33m" # yellow
10 CMSG
="\e[1;32m" # green
11 CINFO
="\e[1;96m" # light blue
12 CDEBUG
="\e[1;94m" # blue
13 CNORMAL
="\e[0;39m" # default system console color
14 CDONE
="\e[1;32m" # green
15 CPASS
="\e[1;32m" # green
16 CFAIL
="\e[1;31m" # red
17 CCMD
="\e[1;35m" # pink
20 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
23 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
26 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
28 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
29 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
32 echo -n "${CINFO}$1${CCMD} " >&2;
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
35 if [ -n "$1" ]; then shift; else break; fi
37 echo -n "…${CNORMAL} " >&2;
39 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
40 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
42 if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2;
43 else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi
44 EXIT_CODE
=$((EXIT_CODE+1));
47 # enable / disable Debugging
48 MSGLEVEL
=${MSGLEVEL:-3}
49 if [ $MSGLEVEL -le 0 ]; then
52 if [ $MSGLEVEL -le 1 ]; then
56 if [ $MSGLEVEL -le 2 ]; then
60 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
61 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
62 if [ -n "$CFAIL" ]; then
63 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
65 msgfail
() { echo -n " ###FAILED###" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
68 if [ $MSGLEVEL -le 3 ]; then
72 if [ $MSGLEVEL -le 4 ]; then
77 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
78 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
79 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
80 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
81 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
84 echo "${CDONE}DONE${CNORMAL}" >&2;
89 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
90 if [ -f .
/aptconfig.conf
]; then
91 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
92 elif [ -f ..
/aptconfig.conf
]; then
93 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
95 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
98 aptconfig
() { runapt apt
-config $
*; }
99 aptcache
() { runapt apt
-cache $
*; }
100 aptcdrom
() { runapt apt
-cdrom $
*; }
101 aptget
() { runapt apt
-get $
*; }
102 aptftparchive
() { runapt apt
-ftparchive $
*; }
103 aptkey
() { runapt apt
-key $
*; }
104 aptmark
() { runapt apt
-mark $
*; }
106 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
109 if [ -f .
/aptconfig.conf
]; then
110 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
111 elif [ -f ..
/aptconfig.conf
]; then
112 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
114 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
119 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1 --args $
*
122 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/http
126 # error if we about to overflow, but ...
127 # "255 failures ought to be enough for everybody"
128 if [ $EXIT_CODE -gt 255 ]; then
129 msgdie
"Total failure count $EXIT_CODE too big"
131 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
134 shellsetedetector
() {
136 if [ "$exit_status" != '0' ]; then
137 echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}"
138 if [ "$EXIT_CODE" = '0' ]; then
139 EXIT_CODE
="$exit_status"
145 if [ "$1" = 'prefix' ]; then
146 CURRENTTRAP
="$2 $CURRENTTRAP"
148 CURRENTTRAP
="$CURRENTTRAP $1"
150 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
154 TMPWORKINGDIRECTORY
=$(mktemp -d)
155 TESTDIRECTORY
=$(readlink -f $(dirname $0))
156 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
157 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
158 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
159 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
160 cd $TMPWORKINGDIRECTORY
161 mkdir rootdir aptarchive keys
163 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
164 mkdir -p var
/cache var
/lib var
/log
165 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
166 touch var
/lib
/dpkg
/available
168 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
170 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
171 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
172 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
174 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
175 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
176 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
178 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
179 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
180 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
181 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
182 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
183 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
184 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
185 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
186 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
187 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
188 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
189 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
190 if ! $(which dpkg) --assert-multi-arch >/dev
/null
2>&1; then
191 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
193 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
194 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
196 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
197 configcompression
'.' 'gz' #'bz2' 'lzma' 'xz'
202 if [ "$1" = "native" -o -z "$1" ]; then
203 eval `aptconfig shell ARCH APT::Architecture`
204 if [ -n "$ARCH" ]; then
207 dpkg
--print-architecture
215 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
218 configarchitecture
() {
220 echo "APT::Architecture \"$(getarchitecture $1)\";"
221 while [ -n "$1" ]; do
222 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
225 } >rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
230 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
231 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
232 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
233 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
235 echo -n > rootdir/var/lib/dpkg/status
238 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
239 if $(which dpkg) --assert-multi-arch >/dev/null 2>&1; then
240 local ARCHS="$(getarchitectures)"
241 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
242 DPKGARCH="$(dpkg --print-architecture)"
243 for ARCH in ${ARCHS}; do
244 if [ "${ARCH}" != "${DPKGARCH}" ]; then
245 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
246 # old-style used e.g. in Ubuntu-P – and as it seems travis
247 echo "DPKG
::options
:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
248 echo "DPKG
::options
:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
252 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
253 # dpkg doesn't really check the version as long as it is fully installed,
254 # but just to be sure we choose one above the required version
255 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
261 configcompression() {
262 while [ -n "$1" ]; do
264 '.') echo ".
\t.
\tcat
";;
265 'gz') echo "gzip\tgz
\tgzip
";;
266 'bz2') echo "bzip2\tbz
2\tbzip
2";;
267 'lzma') echo "lzma
\tlzma
\txz
--format=lzma
";;
268 'xz') echo "xz
\txz
\txz
";;
269 *) echo "$1\t$1\t$1";;
272 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
275 setupsimplenativepackage() {
279 local RELEASE="${4:-unstable}"
280 local DEPENDENCIES="$5"
281 local DESCRIPTION="${6:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
282 If you
find such a package installed on your system
,
283 something went horribly wrong
! They are autogenerated
284 und used only by testcases and surf no other propose…
"}"
286 local SECTION
="${7:-others}"
288 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
291 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
293 local BUILDDIR
=incoming
/${NAME}-${VERSION}
294 mkdir -p ${BUILDDIR}/debian
/source
296 echo "* most suckless software product ever" > FEATURES
297 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
298 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
302 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
303 test -e debian
/control
|| echo "Source: $NAME
306 Maintainer: Joe Sixpack <joe@example.org>
307 Build-Depends: debhelper (>= 7)
308 Standards-Version: 3.9.1
310 Package: $NAME" > debian
/control
311 if [ "$ARCH" = 'all' ]; then
312 echo "Architecture: all" >> debian
/control
314 echo "Architecture: any" >> debian
/control
316 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
317 echo "Description: $DESCRIPTION" >> debian
/control
319 test -e debian
/compat
|| echo "7" > debian
/compat
320 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
321 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
325 buildsimplenativepackage
() {
329 local RELEASE
="${4:-unstable}"
330 local DEPENDENCIES
="$5"
331 local DESCRIPTION
="${6:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
332 If you find such a package installed on your system,
333 something went horribly wrong! They are autogenerated
334 und used only by testcases and surf no other propose…"}"
336 local SECTION="${7:-others}"
337 local PRIORITY="${8:-optional}"
340 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
343 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
345 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
347 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
348 mkdir -p $BUILDDIR/debian/source
349 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
351 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
353 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
354 echo "$NAME ($VERSION) $RELEASE; urgency
=low
358 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
362 Maintainer
: Joe Sixpack
<joe@example.org
>
363 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
364 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
365 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
367 Package
: $NAME" >> ${BUILDDIR}/debian/control
369 if [ "$ARCH" = 'all' ]; then
370 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
372 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
374 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
375 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
376 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
378 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
379 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
381 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
382 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
383 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
384 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
385 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
386 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
390 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
391 rm -rf ${BUILDDIR}/debian
/tmp
392 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
393 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
394 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
395 if [ -n "$FILE_TREE" ]; then
396 cp -ar "$FILE_TREE" ${BUILDDIR}/debian
/tmp
399 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
400 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
401 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
402 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
405 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
406 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
407 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
416 local ARCH
=$(getarchitecture $4)
417 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
419 if [ "$ARCH" = "all" ]; then
420 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
422 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
423 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
424 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
427 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
430 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
436 if [ -d incoming
]; then
437 buildaptarchivefromincoming $
*
439 buildaptarchivefromfiles $
*
443 createaptftparchiveconfig
() {
444 local COMPRESSORS
="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
445 COMPRESSORS
="${COMPRESSORS%* }"
446 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
447 if [ -z "$ARCHS" ]; then
448 # the pool is empty, so we will operate on faked packages - let us use the configured archs
449 ARCHS
="$(getarchitectures)"
452 ArchiveDir "' >> ftparchive.conf
453 echo -n $(readlink -f .) >> ftparchive.conf
455 CacheDir "' >> ftparchive.conf
456 echo -n $(readlink -f ..) >> ftparchive.conf
458 FileListDir "' >> ftparchive.conf
459 echo -n $(readlink -f pool/) >> ftparchive.conf
463 Packages::Compress "'"$COMPRESSORS"'";
464 Sources::Compress "'"$COMPRESSORS"'";
465 Contents::Compress "'"$COMPRESSORS"'";
466 Translation::Compress "'"$COMPRESSORS"'";
467 LongDescription "false";
471 SrcDirectory "pool/";
477 Label "apttestcases";
479 Description "repository with dummy packages";
480 Architectures "' >> ftparchive.conf
481 echo -n "$ARCHS" >> ftparchive.conf
485 };' >> ftparchive.conf
486 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
487 echo -n 'tree "dists/' >> ftparchive.conf
488 echo -n "$DIST" >> ftparchive.conf
490 Architectures "' >> ftparchive.conf
491 echo -n "$ARCHS" >> ftparchive.conf
493 FileList "' >> ftparchive.conf
494 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
496 SourceFileList "' >> ftparchive.conf
497 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
499 Sections "' >> ftparchive.conf
500 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
502 };' >> ftparchive.conf
506 buildaptftparchivedirectorystructure
() {
507 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
508 for DIST
in $DISTS; do
509 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
510 for SECTION
in $SECTIONS; do
511 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
512 for ARCH
in $ARCHS; do
513 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
515 mkdir -p dists
/${DIST}/${SECTION}/source
516 mkdir -p dists
/${DIST}/${SECTION}/i18n
526 local DEPENDENCIES
="$5"
527 local PRIORITY
="${6:-optional}"
528 local DESCRIPTION
="${7:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
529 If you find such a package installed on your system,
530 something went horribly wrong! They are autogenerated
531 und used only by testcases and surf no other propose…"}"
533 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
534 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
535 ARCHS
="$(getarchitectures)"
539 for BUILDARCH
in $ARCHS; do
540 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
541 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
542 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
543 local FILE
="${PPATH}/Packages"
548 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
549 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
550 echo "Version: $VERSION
551 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
552 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
553 echo "Description: $DESCRIPTION" >> $FILE
564 local DEPENDENCIES
="$5"
566 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
568 local FILE
="${SPATH}/Sources"
572 Maintainer: Joe Sixpack <joe@example.org>
573 Architecture: $ARCH" >> $FILE
574 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
576 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
577 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
581 insertinstalledpackage
() {
585 local DEPENDENCIES
="$4"
586 local PRIORITY
="${5:-optional}"
587 local STATUS
="${6:-install ok installed}"
588 local DESCRIPTION
="${7:-"Description: an autogenerated dummy ${NAME}=${VERSION}/installed
589 If you find such a package installed on your system,
590 something went horribly wrong! They are autogenerated
591 und used only by testcases and surf no other propose…"}"
593 local FILE='rootdir/var/lib/dpkg/status'
594 local INFO='rootdir/var/lib/dpkg/info'
595 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
601 Maintainer: Joe Sixpack <joe@example.org>
602 Version: $VERSION" >> $FILE
603 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
604 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
605 echo "Description: $DESCRIPTION" >> $FILE
607 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
608 echo -n > ${INFO}/${NAME}:${arch}.list
610 echo -n > ${INFO}/${NAME}.list
616 buildaptarchivefromincoming
() {
617 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
619 [ -e pool
] || ln -s ..
/incoming pool
620 [ -e ftparchive.conf
] || createaptftparchiveconfig
621 [ -e dists
] || buildaptftparchivedirectorystructure
622 msgninfo
"\tGenerate Packages, Sources and Contents files… "
623 aptftparchive
-qq generate ftparchive.conf
629 buildaptarchivefromfiles
() {
630 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
631 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
632 msgninfo
"\t${line} file… "
633 compressfile
"$line" "$1"
636 generatereleasefiles
"$@"
640 cat ${TMPWORKINGDIRECTORY}/rootdir
/etc
/testcase
-compressor.conf
| while read compressor extension
command; do
641 if [ "$compressor" = '.' ]; then
647 cat "$1" | $command > "${1}.${extension}"
649 touch -d "$2" "${1}.${extension}"
654 # can be overridden by testcases for their pleasure
655 getcodenamefromsuite
() { echo -n "$1"; }
656 getreleaseversionfromsuite
() { true
; }
657 getlabelfromsuite
() { true
; }
659 generatereleasefiles
() {
660 # $1 is the Date header and $2 is the ValidUntil header to be set
661 # both should be given in notation date/touch can understand
662 msgninfo
"\tGenerate Release files… "
663 if [ -e aptarchive
/dists
]; then
664 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
665 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
666 local CODENAME
="$(getcodenamefromsuite $SUITE)"
667 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
668 local LABEL
="$(getlabelfromsuite $SUITE)"
669 if [ -n "$VERSION" ]; then
670 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
672 if [ -n "$LABEL" ]; then
673 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
675 aptftparchive
-qq release
$dir \
676 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
677 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
680 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
681 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
683 NotAutomatic: yes' $dir/Release
685 if [ -n "$1" -a "$1" != "now" ]; then
686 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
690 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
694 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
696 if [ -n "$1" -a "$1" != "now" ]; then
697 for release
in $(find ./aptarchive -name 'Release'); do
698 touch -d "$1" $release
704 setupdistsaptarchive
() {
705 local APTARCHIVE
=$(readlink -f ./aptarchive)
706 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
707 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
708 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
709 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
710 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
711 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
712 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
717 setupflataptarchive
() {
718 local APTARCHIVE
=$(readlink -f ./aptarchive)
719 if [ -f ${APTARCHIVE}/Packages
]; then
720 msgninfo
"\tadd deb sources.list line… "
721 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
724 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
726 if [ -f ${APTARCHIVE}/Sources
]; then
727 msgninfo
"\tadd deb-src sources.list line… "
728 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
731 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
737 if [ -e aptarchive
/dists
]; then
743 if [ "$1" != '--no-update' ]; then
744 msgninfo
"\tSync APT's cache with the archive… "
751 local SIGNER
="${1:-Joe Sixpack}"
752 local GPG
="gpg --batch --yes --no-default-keyring --trustdb-name rootdir/etc/apt/trustdb.gpg"
753 msgninfo
"\tSign archive with $SIGNER key… "
754 local REXKEY
='keys/rexexpired'
755 local SECEXPIREBAK
="${REXKEY}.sec.bak"
756 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
757 if [ "${SIGNER}" = 'Rex Expired' ]; then
758 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
759 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
760 # therefore we 'temporary' make the key not expired and restore a backup after signing
761 cp ${REXKEY}.sec
$SECEXPIREBAK
762 cp ${REXKEY}.pub
$PUBEXPIREBAK
763 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
764 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
765 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
766 cp $SECUNEXPIRED ${REXKEY}.sec
767 cp $PUBUNEXPIRED ${REXKEY}.pub
769 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub
--secret-keyring ${REXKEY}.sec
--command-fd 0 --edit-key "${SIGNER}" >/dev
/null
2>&1 || true
770 cp ${REXKEY}.sec
$SECUNEXPIRED
771 cp ${REXKEY}.pub
$PUBUNEXPIRED
774 for KEY
in $(find keys/ -name '*.sec'); do
775 GPG
="$GPG --secret-keyring $KEY"
777 for KEY
in $(find keys/ -name '*.pub'); do
778 GPG
="$GPG --keyring $KEY"
780 for RELEASE
in $(find aptarchive/ -name Release); do
781 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
782 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
783 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
784 # we might have set a specific date for the Release file, so copy it
785 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
787 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
788 mv -f $SECEXPIREBAK ${REXKEY}.sec
789 mv -f $PUBEXPIREBAK ${REXKEY}.pub
794 rewritesourceslist
() {
795 local APTARCHIVE
="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
796 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
797 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
801 changetowebserver
() {
802 local LOG
='/dev/null'
803 if test -x ${BUILDDIRECTORY}/aptwebserver
; then
805 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/aptwebserver
-o aptwebserver
::fork
=1 "$@" >$LOG 2>&1
806 local PID
="$(cat aptwebserver.pid)"
807 if [ -z "$PID" ]; then
808 msgdie
'Could not fork aptwebserver successfully'
813 msgdie
'You have to build aptwerbserver or install a webserver'
815 if [ "$1" != '--no-rewrite' ]; then
816 rewritesourceslist
'http://localhost:8080/'
820 changetohttpswebserver
() {
821 if ! which stunnel4
>/dev
/null
; then
822 msgdie
'You need to install stunnel4 for https testcases'
824 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
825 changetowebserver
--no-rewrite
827 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
828 cert = ${TESTDIRECTORY}/apt.pem
833 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
834 stunnel4
"${TMPWORKINGDIRECTORY}/stunnel.conf"
835 local PID
="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
836 addtrap
'prefix' "kill ${PID};"
837 rewritesourceslist
'https://localhost:4433/'
841 mkdir -p rootdir
/media
/cdrom
/.disk
842 local CD
="$(readlink -f rootdir/media/cdrom)"
843 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
844 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
845 echo -n "$1" > ${CD}/.disk
/info
846 if [ ! -d aptarchive
/dists
]; then
847 msgdie
'Flat file archive cdroms can not be created currently'
850 mv aptarchive
/dists
$CD
851 ln -s "$(readlink -f ./incoming)" $CD/pool
852 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
856 PROTO
="$(echo "$1" | cut -d':' -f 1)"
857 local DOWNLOG
="${TMPWORKINGDIRECTORY}/download.log"
861 echo "601 Configuration
862 Config-Item: Acquire::https::CaInfo=${TESTDIR}/apt.pem
863 Config-Item: Debug::Acquire::${PROTO}=1
869 # simple worker keeping stdin open until we are done (201) or error (400)
870 # and requesting new URIs on try-agains/redirects inbetween
871 { tail -n 999 -f "$DOWNLOG" & echo "TAILPID: $!"; } | while read f1 f2
; do
872 if [ "$f1" = 'TAILPID:' ]; then
874 elif [ "$f1" = 'New-URI:' ]; then
875 echo "600 Acquire URI
879 elif [ "$f1" = '201' ] || [ "$f1" = '400' ]; then
880 # tail would only die on next read – which never happens
881 test -z "$TAILPID" || kill -s HUP
"$TAILPID"
885 } | LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/${PROTO} 2>&1 | tee "$DOWNLOG"
887 # only if the file exists the download was successful
896 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
897 if [ -n "$DIFFTEXT" ]; then
909 msgtest
"Test for correctness of file" "$FILE"
911 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
913 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
918 msgtest
"Test for no output of" "$*"
919 test -z "$($* 2>&1)" && msgpass
|| msgfail
923 local COMPAREFILE
=$(mktemp)
924 addtrap
"rm $COMPAREFILE;"
925 echo "$1" > $COMPAREFILE
927 msgtest
"Test for equality of" "$*"
928 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
932 local COMPAREFILE1
=$(mktemp)
933 local COMPAREFILE2
=$(mktemp)
934 local COMPAREAGAINST
=$(mktemp)
935 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
936 echo "$1" > $COMPAREFILE1
937 echo "$2" > $COMPAREFILE2
939 msgtest
"Test for equality OR of" "$*"
940 $
* >$COMPAREAGAINST 2>&1 || true
941 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
942 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
943 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
944 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
949 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
952 while [ -n "$1" ]; do
954 N: Can't select versions from package '$1' as it is purely virtual"
955 PACKAGE
="${PACKAGE} $1"
958 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
960 N: No packages found"
961 local COMPAREFILE
=$(mktemp)
962 addtrap
"rm $COMPAREFILE;"
963 local ARCH
="$(getarchitecture 'native')"
964 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
965 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
969 msgtest
"Test for non-existent packages" "apt-cache show $*"
970 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
971 if [ -n "$SHOWPKG" ]; then
980 testdpkginstalled
() {
981 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
982 local PKGS
="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
983 if [ "$PKGS" != $# ]; then
985 dpkg
-l $
* | grep '^[a-z]'
992 testdpkgnotinstalled
() {
993 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
994 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
995 if [ "$PKGS" != 0 ]; then
997 dpkg
-l $
* | grep '^[a-z]'
1005 local COMPAREFILE
=$(mktemp)
1006 addtrap
"rm $COMPAREFILE;"
1007 if [ -n "$1" ]; then
1008 msgtest
'Test for correctly marked as auto-installed' "$*"
1009 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1011 msgtest
'Test for correctly marked as auto-installed' 'no package'
1012 echo -n > $COMPAREFILE
1014 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1018 if [ "$1" = '--nomsg' ]; then
1021 msgtest
'Test for successful execution of' "$*"
1023 local OUTPUT
=$(mktemp)
1024 addtrap
"rm $OUTPUT;"
1025 if $@
>${OUTPUT} 2>&1; then
1035 if [ "$1" = '--nomsg' ]; then
1038 msgtest
'Test for failure in execution of' "$*"
1040 local OUTPUT
=$(mktemp)
1041 addtrap
"rm $OUTPUT;"
1042 if $@
>${OUTPUT} 2>&1; then
1052 echo "STOPPED execution. Press enter to continue"